<template>
  <BasicModal v-bind="$attrs" @register="registerModal" :title="title" @ok="handleSubmit" width="40%">
    <BasicForm @register="registerForm"> </BasicForm>
  </BasicModal>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form/index';
  import { FormSchema } from '/@/components/Table';
  import { updateQrjl } from '../api';
  import { useMessage } from '/@/hooks/web/useMessage';
  // Emits声明
  const { createMessage } = useMessage();
  const emit = defineEmits(['register', 'success']);

  const AdviceFormSchema: FormSchema[] = [
    { label: '污染地块ID', field: 'wrdkid', component: 'Input', show: false },
    { label: 'type', field: 'type', component: 'Input', show: false },
    { label: 'zglx', field: 'zglx', component: 'Input', show: false },
    {
      label: '是否确认',
      field: 'sfqr',
      component: 'RadioGroup',
      required: true,
      componentProps: {
        //options里面由一个一个的radio组成,支持disabled
        options: [
          { label: '是', value: 1 },
          { label: '退回', value: 0 },
        ],
      },
    },
    {
      label: '相关材料上传',
      field: 'xgcl',
      component: 'JUpload',
      componentProps: {
        fileName: '相关材料上传',
        showUploadList: false,
        accept: '.pdf,.zip',
        beforeUpload: (file) => {
          let isshow = false;
          const isFile = file.name.split('.')[file.name.split('.').length - 1];
          console.log(file, 'file');
          if (isFile == 'pdf' || isFile == 'zip' || isFile == 'PDF') {
            isshow = true;
          } else {
            createMessage.error('只能上传.pdf/.zip格式的文件');
            isshow = false;
          }
          return isshow;
        },
      },
    },
    {
      label: '备注',
      field: 'bz',
      component: 'InputTextArea',
      componentProps: {
        rows: 3,
      },
    },
  ];
  //表单配置
  const [registerForm, { resetFields, setFieldsValue, validate }] = useForm({
    labelWidth: 220,
    schemas: AdviceFormSchema,
    showActionButtonGroup: false,
  });
  //设置标题
  const title = ref('所在部门确认');
  //表单赋值
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async (data) => {
    //重置表单
    title.value = data.title;
    await resetFields();
    setModalProps({ confirmLoading: false, showCancelBtn: data?.showFooter, showOkBtn: data?.showFooter });

    //表单赋值
    await setFieldsValue({
      ...data.record,
    });
  });

  //表单提交事件
  async function handleSubmit() {
    try {
      let values = await validate();
      setModalProps({ confirmLoading: true });
      //提交表单
      await updateQrjl(values);
      emit('success');
      //关闭弹窗
      closeModal();
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>

<style lang="less" scoped></style>
